Index: trunk/LMDZ.TITAN/libf/muphytitan/fsystem.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/fsystem.F90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/muphytitan/fsystem.F90	(revision 1897)
@@ -1,5 +1,5 @@
-! Copyright Jérémie Burgalat (2010-2015)
+! Copyright Jérémie Burgalat (2010-2015,2017)
 ! 
-! burgalat.jeremie@gmail.com
+! jeremie.burgalat@univ-reims.fr
 ! 
 ! This software is a computer program whose purpose is to provide configuration 
@@ -33,7 +33,8 @@
 
 !! file: fsystem.F90
-!! summary: File system methods source file
-!! date: 2013-2015
-!! author: Burgalat
+!! summary: File system methods source file.
+!! author: J. Burgalat
+!! date: 2013-2015,2017
+
 
 #include "defined.h"
@@ -48,10 +49,31 @@
 
   PRIVATE :: get_umask
+  PRIVATE :: c2t
 
   INTEGER, PARAMETER :: MAX_PATH = 512 !! Maximum length of a path
 
-
+  TYPE, PUBLIC :: chrono
+    !! Define a simple chronometer
+    !!
+    !! This object can be used to get an approximation of the execution of some piece of code.
+    REAL(kind=8), PRIVATE    :: cpu_start = 0d0   
+      !! Starting CPU time
+    INTEGER(kind=8), PRIVATE :: clock_start = 0d0 
+      !! Starting clock time
+    LOGICAL, PRIVATE         :: on_run = .false.
+      !! Chrono running state.
+#if HAVE_FTNPROC
+    CONTAINS 
+      PROCEDURE :: is_running => chrono_is_running 
+      PROCEDURE :: start      => chrono_start
+      PROCEDURE :: stop       => chrono_stop
+      PROCEDURE :: reset      => chrono_reset
+      PROCEDURE :: get        => chrono_get
+#endif
+  END TYPE chrono
+
+#ifndef FORD_DOC
+  ! C interfaces
   INTERFACE
-
     FUNCTION strlen_c(s) RESULT(length) bind(C,name="strlen")
       !! Get length of C-string up to (but not including) the terminator
@@ -68,5 +90,5 @@
 
     FUNCTION errno_c() BIND(C,name="c_get_errno")
-      !! Get last error numbero
+      !! Get last error numero
       IMPORT C_INT
       INTEGER(kind=C_INT) :: errno_c !! Last errno
@@ -209,4 +231,12 @@
       INTEGER(kind=C_INT)                    :: mkdirp_c   !! 0 on success, last errno on failure 
     END FUNCTION mkdirp_c
+
+    FUNCTION copy_c(to,from) BIND(C,name="c_copy") 
+      !! Copy a file.
+      IMPORT c_char, C_INT
+      CHARACTER(kind=c_char), INTENT(in)  :: to(*)    !! Destination path.
+      CHARACTER(kind=c_char), INTENT(in)  :: from(*)  !! Input file path to copy.
+      INTEGER(kind=C_INT)                 :: copy_c !! 0 on success, 1 on failure.
+    END FUNCTION copy_c
 
     FUNCTION remove_c(path) BIND(C,name="c_remove") 
@@ -255,6 +285,26 @@
     END FUNCTION termsize_c
 
+    FUNCTION getCurrentRSS_c() BIND(C, name="c_getCurrentRSS")
+      !! Get the current resident set size memory in bytes.
+      IMPORT  C_SIZE_T
+      INTEGER(kind=C_SIZE_T) :: getCurrentRSS_c !! Current resident set size in bytes (0 if not available).
+    END FUNCTION getCurrentRSS_c 
+
+    FUNCTION getPeakRSS_c() BIND(C, name="c_getPeakRSS")
+      !! Get the peak resident set size memory in bytes.
+      IMPORT  C_SIZE_T
+      INTEGER(kind=C_SIZE_T) :: getPeakRSS_c !! Peak resident set size in bytes (0 if not available).
+    END FUNCTION getPeakRSS_c 
+
+    FUNCTION getSystemMemory_c(total,avail,free) BIND(C, name='c_getSystemMemory')
+      !! Get global memory informations.
+      IMPORT C_LONG_LONG,C_INT
+      INTEGER(kind=C_LONG_LONG), INTENT(out) :: total             !! Total available memory.
+      INTEGER(kind=C_LONG_LONG), INTENT(out) :: avail             !! Current available memory.
+      INTEGER(kind=C_LONG_LONG), INTENT(out) :: free              !! Current free memory.
+      INTEGER(kind=C_INT)                    :: getSystemMemory_c !! status, 0 on success, 1 otherwise. 
+    END FUNCTION getSystemMemory_c
   END INTERFACE
-
+#endif
 
   CONTAINS
@@ -291,5 +341,5 @@
     !! @attention
     !! The method does not free the underlying C string and it should be free using 
-    !! [[fsystem(module):free_c(interface)]] method.
+    !! the subroutine free_c(_cstr_).
     TYPE(C_PTR), INTENT(in) :: cstr
       !! A TYPE(C_PTR) that represent the pointer to the C char array.
@@ -476,4 +526,17 @@
     RETURN
   END FUNCTION fs_getcwd
+
+  FUNCTION fs_copy(input,output) RESULT(ret)
+    !! Copy input file into output file.
+    CHARACTER(len=*), INTENT(in)  :: input  !! Input file path to copy.
+    CHARACTER(len=*), INTENT(in)  :: output !! Output file path destination.
+    LOGICAL :: ret                          !! True on success, false otherwise.
+    IF (LEN_TRIM(input) == 0 .OR. LEN_TRIM(output) == 0 .OR. input == output) THEN
+      ret = .false.
+    ELSE
+      ret = INT(copy_c(cstring(ADJUSTL(output)),cstring(ADJUSTL(input)))) == 0
+    ENDIF
+    RETURN
+  END FUNCTION fs_copy
 
   FUNCTION fs_remove(path) RESULT(ret)
@@ -880,4 +943,69 @@
   END SUBROUTINE fs_msleep
 
+  FUNCTION fs_get_memory(peak,units) RESULT(mem)
+    !! Get the memory usage of the current process.
+    LOGICAL, INTENT(in), OPTIONAL          :: peak  !! True to retrieve the peak RSS memory, otherwise retrieve the current RSS memory. Default to False.
+    CHARACTER(len=*), INTENT(in), OPTIONAL :: units !! Output units: either 'B' (Bytes),'KB' (Kilo-),'MB' (Mega-),'GB' (Giga-). Default to 'B'.
+    REAL(kind=8)                           :: mem   !! Memory usage.
+    LOGICAL          :: zpeak
+    CHARACTER(len=2) :: zunits
+    zpeak = .false. ; IF (PRESENT(peak)) zpeak = peak
+    zunits = 'B '   ; IF (PRESENT(units)) zunits = units
+    IF (zunits /= 'B' .AND. zunits /= 'KB' .AND. zunits /= 'MB' .AND. zunits /= 'GB') zunits = 'B '
+    IF (zpeak) THEN
+      mem = REAL(getPeakRSS_c(),kind=8)
+    ELSE
+      mem = REAL(getCurrentRSS_c(),kind=8)
+    ENDIF
+    IF (zunits == 'KB') THEN
+      mem = mem / 1024d0
+    ELSE IF (zunits == 'MB') THEN
+      mem = mem / 1048576d0
+    ELSE IF (zunits == 'GB') THEN
+      mem = mem / 1073741824d0
+    ENDIF
+    RETURN
+  END FUNCTION fs_get_memory
+
+  FUNCTION fs_get_system_memory(total,available,free,units) RESULT(ret)
+    !! Get informations about system memory.
+    !!
+    !! If no informations is available, output arguments are set to 0 and the method returns false.
+    REAL(kind=8), INTENT(out), OPTIONAL    :: total      !! Total available memory.
+    REAL(kind=8), INTENT(out), OPTIONAL    :: available  !! Current available memory.
+    REAL(kind=8), INTENT(out), OPTIONAL    :: free       !! Current free memory.
+    CHARACTER(len=*), INTENT(in), OPTIONAL :: units      !! Output units: either 'B' (Bytes),'KB' (Kilo-),'MB' (Mega-),'GB' (Giga-). Default to 'B'.
+    LOGICAL                                :: ret        !! True on success, false otherwise.
+    LOGICAL          :: zpeak
+    CHARACTER(len=2) :: zunits
+    INTEGER(kind=8)  :: ztot,zava,zfre    
+
+    zunits = 'B '   ; IF (PRESENT(units)) zunits = units
+    IF (zunits /= 'B' .AND. zunits /= 'KB' .AND. zunits /= 'MB' .AND. zunits /= 'GB') zunits = 'B '
+    ret = INT(getSystemMemory_c(ztot,zava,zfre),kind=4) == 0
+    ztot = ztot * 1024 ; zava = zava * 1024 ; zfre = zfre * 1024 
+
+    IF (PRESENT(total))     total     = ztot
+    IF (PRESENT(available)) available = zava
+    IF (PRESENT(free))      free      = zfre
+    IF (.NOT.ret) RETURN
+
+    IF (zunits == 'KB') THEN
+      IF (PRESENT(total))     total     = ztot / 1024d0
+      IF (PRESENT(available)) available = zava / 1024d0
+      IF (PRESENT(free))      free      = zfre / 1024d0
+    ELSE IF (zunits == 'MB') THEN
+      IF (PRESENT(total))     total     = ztot / 1048576d0
+      IF (PRESENT(available)) available = zava / 1048576d0
+      IF (PRESENT(free))      free      = zfre / 1048576d0
+    ELSE IF (zunits == 'GB') THEN
+      IF (PRESENT(total))     total     = ztot / 1073741824d0
+      IF (PRESENT(available)) available = zava / 1073741824d0
+      IF (PRESENT(free))      free      = zfre / 1073741824d0
+    ENDIF
+    RETURN
+  END FUNCTION fs_get_system_memory
+
+
 !===============================================================================
 ! MODULE MISCELLANEOUS METHODS
@@ -1032,3 +1160,102 @@
   END FUNCTION sz2str
 
+  FUNCTION chrono_is_running(this) RESULT (ret)
+    !! Get chrono's state.
+    OBJECT(chrono), INTENT(in) :: this !! Chrono object reference.
+    LOGICAL :: ret                    !! Running state.
+    ret = this%on_run
+    RETURN
+  END FUNCTION chrono_is_running
+
+  SUBROUTINE chrono_start(this)
+    !! Start the chrono. 
+    !!
+    !! @note
+    !! Calling the method multiple times without explicitly stopping the chrono
+    !! [[chrono(type):stop(bound)]] does nothing (except for the first called).
+    OBJECT(chrono), INTENT(inout) :: this  !! Chrono object reference.
+    IF (.NOT.this%on_run) THEN
+      CALL CPU_TIME(this%cpu_start)
+      CALL SYSTEM_CLOCK(this%clock_start)
+    ENDIF
+    this%on_run = .true.
+  END SUBROUTINE chrono_start 
+
+  SUBROUTINE chrono_stop(this)
+    !! Stop the chrono.
+    OBJECT(chrono), INTENT(inout) :: this !! Chrono object reference.
+    REAL(kind=8)    :: ecpu
+    INTEGER(kind=8) :: eclk,nbm,nbr
+    this%on_run = .false.
+  END SUBROUTINE chrono_stop
+
+  SUBROUTINE chrono_reset(this)
+    !! Reset the chrono's internal elapsed times.
+    OBJECT(chrono), INTENT(inout) :: this !! Chrono object reference.
+    CALL CPU_TIME(this%cpu_start)
+    CALL SYSTEM_CLOCK(this%clock_start)
+  END SUBROUTINE chrono_reset
+
+  SUBROUTINE chrono_get(this,cpu,clock,units) 
+    !! Get elapsed time since last call of start or reset methods.
+    !! 
+    !! The method computes the time elapsed in two ways :
+    !!
+    !! - If the [[fsystem(module):chrono(type)]] is not running, the method retruns 0.
+    !! - Otherwise, elapsed time since the last call of 
+    !!   [[chrono(type):start(bound)]] (or [[chrono(type):reset(bound)]]).
+    OBJECT(chrono), INTENT(in)             :: this
+      !! Chrono object reference.
+    REAL(kind=8), INTENT(out), OPTIONAL    :: cpu
+      !! Elapsed cpu time in seconds by default (see units argument).
+    REAL(kind=8), INTENT(out), OPTIONAL    :: clock 
+      !! Elapsed system clock time in seconds by default (see units argument).
+    CHARACTER(len=2), INTENT(in), OPTIONAL :: units
+      !! A two characters wide string with the units to convert in. Units should
+      !! be one of the following : 'ms', 's' (default), 'm', 'h' or 'd'. 
+    CHARACTER(len=2) :: zu
+    REAL(kind=8)     :: cu, fact
+    INTEGER(kind=8)  :: ck, r, m
+    IF (this%on_run) THEN
+      IF (PRESENT(cpu)) THEN
+        CALL CPU_TIME(cu)
+        cpu = (cu - this%cpu_start)
+      ENDIF
+      IF (PRESENT(clock)) THEN
+        CALL SYSTEM_CLOCK(ck,r,m) 
+        clock = c2t(ck,this%clock_start,r,m)
+      ENDIF
+    ELSE
+      IF (PRESENT(cpu))   cpu = 0d0
+      IF (PRESENT(clock)) clock = 0d0
+    ENDIF
+    fact = 1d0
+    zu = 's' 
+    IF (PRESENT(units))  THEN
+      zu = units
+      SELECT CASE(zu)
+        CASE ('d') ; fact = 3600d0*24.
+        CASE ('h') ; fact = 3600d0
+        CASE ('m') ; fact = 60d0
+        CASE ('ms') ; fact = 1d-3
+        CASE DEFAULT ; fact = 1d0
+      END SELECT
+    ENDIF
+    IF (PRESENT(cpu)) cpu = cpu / fact 
+    IF (PRESENT(clock)) clock = clock / fact
+  END SUBROUTINE chrono_get
+
+  FUNCTION c2t(e,i,r,m) RESULT(time)
+    !! Get the real-time between two clock counts from system_clock.
+    INTEGER(kind=8), INTENT(in) :: e !! Final clock count
+    INTEGER(kind=8), INTENT(in) :: i !! Initial clock count 
+    INTEGER(kind=8), INTENT(in) :: r !! Clock count rate
+    INTEGER(kind=8), INTENT(in) :: m !! Maximum Clock count value
+    REAL(kind=8)    :: time          !! Time in seconds
+    INTEGER(kind=8) :: nc
+    nc = e-i ; IF (e < i) nc = nc+m
+    time = REAL(nc,kind=8)/r
+    RETURN
+  END FUNCTION c2t
 END MODULE FSYSTEM
+
Index: trunk/LMDZ.TITAN/libf/muphytitan/mm_clouds.f90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/mm_clouds.f90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/muphytitan/mm_clouds.f90	(revision 1897)
@@ -1,3 +1,3 @@
-! Copyright 2013-2015 Université de Reims Champagne-Ardenne 
+! Copyright 2013-2015,2017 Université de Reims Champagne-Ardenne 
 ! Contributor: J. Burgalat (GSMA, URCA)
 ! email of the author : jeremie.burgalat@univ-reims.fr
@@ -35,5 +35,5 @@
 !! summary: Clouds microphysics module
 !! author: J. Burgalat
-!! date: 2013-2015
+!! date: 2013-2015,2017
 
 MODULE MM_CLOUDS
Index: trunk/LMDZ.TITAN/libf/muphytitan/mm_globals.f90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/mm_globals.f90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/muphytitan/mm_globals.f90	(revision 1897)
@@ -1,3 +1,3 @@
-! Copyright 2013-2015 Université de Reims Champagne-Ardenne 
+! Copyright 2013-2015,2017 Université de Reims Champagne-Ardenne 
 ! Contributor: J. Burgalat (GSMA, URCA)
 ! email of the author : jeremie.burgalat@univ-reims.fr
@@ -35,5 +35,5 @@
 !! summary: Parameters and global variables module.
 !! author: J. Burgalat
-!! date: 2013-2015
+!! date: 2013-2015,2017
 
 MODULE MM_GLOBALS
@@ -141,5 +141,5 @@
   ! from swift
   USE CFGPARSE
-  USE STRINGS
+  USE STRING_OP
   USE ERRORS
   IMPLICIT NONE
@@ -166,6 +166,6 @@
   PROTECTED :: mm_rcs, mm_rcf, mm_drad, mm_drho
 
-  LOGICAL, SAVE :: mm_debug = .true.  !! Enable QnD debug mode.
-  LOGICAL, SAVE :: mm_log = .false.   !! Enable log mode.
+  LOGICAL, SAVE :: mm_debug = .true.  !! Enable QnD debug mode (can be used for devel).
+  LOGICAL, SAVE :: mm_log = .false.   !! Enable log mode (for configuration only).
 
   LOGICAL, SAVE :: mm_w_haze_prod = .true. !! Enable/Disable haze production.
@@ -177,4 +177,6 @@
 
   LOGICAL, SAVE :: mm_var_prod = .false. !! Time variation of production rate control flag.
+
+  LOGICAL, SAVE :: mm_use_effg = .true. !! Enable/Disable effective G for computations.
 
   !> Enable/Disable __Fiadero__'s correction.
@@ -689,5 +691,5 @@
       ALLOCATE(mm_spcname(mm_nesp),mm_xESPS(mm_nesp))
       DO i=1,mm_nesp
-        mm_spcname(i) = str_to_lower(species(i))
+        mm_spcname(i) = to_lower(species(i))
         IF(.NOT.cfg_has_section(cp,TRIM(mm_spcname(i)))) THEN
           err = error("mm_global_init: Cannot find "//TRIM(mm_spcname(i))//" properties",-1)
@@ -866,5 +868,5 @@
       !mm_spcname(1:mm_nesp) = species(:)
       DO i=1,mm_nesp
-        mm_spcname(i) = str_to_lower(species(i))
+        mm_spcname(i) = to_lower(species(i))
         IF (.NOT.cfg_has_section(spccfg,TRIM(mm_spcname(i)))) THEN
           err = error("mm_global_init: Cannot find "//TRIM(mm_spcname(i))//" properties",-1)
@@ -1214,5 +1216,6 @@
     REAL(kind=mm_wp), INTENT(in) :: z !! Altitude in meters
     REAL(kind=mm_wp) :: effg          !! Effective gravitational acceleration in \(m.s^{-2}\)
-    effg = mm_g0 * (mm_rpla/(mm_rpla+z))**2
+    effg = mm_g0
+    IF (mm_use_effg) effg = effg * (mm_rpla/(mm_rpla+z))**2
     RETURN
   END FUNCTION mm_effg 
Index: trunk/LMDZ.TITAN/libf/muphytitan/mm_haze.f90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/mm_haze.f90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/muphytitan/mm_haze.f90	(revision 1897)
@@ -1,3 +1,3 @@
-! Copyright 2013-2015 Université de Reims Champagne-Ardenne 
+! Copyright 2013-2015,2017 Université de Reims Champagne-Ardenne 
 ! Contributor: J. Burgalat (GSMA, URCA)
 ! email of the author : jeremie.burgalat@univ-reims.fr
@@ -35,6 +35,5 @@
 !! summary: Haze microphysics module.
 !! author: J. Burgalat
-!! date: 2013-2015
-
+!! date: 2013-2015,2017
 MODULE MM_HAZE
   !! Haze microphysics module.
Index: trunk/LMDZ.TITAN/libf/muphytitan/mm_interfaces.f90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/mm_interfaces.f90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/muphytitan/mm_interfaces.f90	(revision 1897)
@@ -1,3 +1,3 @@
-! Copyright 2013-2015 Université de Reims Champagne-Ardenne 
+! Copyright 2013-2015,2017 Université de Reims Champagne-Ardenne 
 ! Contributor: J. Burgalat (GSMA, URCA)
 ! email of the author : jeremie.burgalat@univ-reims.fr
@@ -35,5 +35,5 @@
 !! summary: Interfaces module for external functions
 !! author: J. Burgalat
-!! date: 2013-2015
+!! date: 2013-2015,2017
 
 MODULE MM_INTERFACES
Index: trunk/LMDZ.TITAN/libf/muphytitan/mm_lib.f90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/mm_lib.f90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/muphytitan/mm_lib.f90	(revision 1897)
@@ -1,3 +1,3 @@
-! Copyright 2013-2015 Université de Reims Champagne-Ardenne 
+! Copyright 2013-2015,2017 Université de Reims Champagne-Ardenne 
 ! Contributor: J. Burgalat (GSMA, URCA)
 ! email of the author : jeremie.burgalat@univ-reims.fr
@@ -35,5 +35,5 @@
 !! summary: MP2M library interface module.
 !! author: J. Burgalat
-!! date: 2013-2015
+!! date: 2013-2015,2017
 
 MODULE MM_LIB
Index: trunk/LMDZ.TITAN/libf/muphytitan/mm_methods.f90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/mm_methods.f90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/muphytitan/mm_methods.f90	(revision 1897)
@@ -1,3 +1,3 @@
-! Copyright 2013-2015 Université de Reims Champagne-Ardenne 
+! Copyright 2013-2015,2017 Université de Reims Champagne-Ardenne 
 ! Contributor: J. Burgalat (GSMA, URCA)
 ! email of the author : jeremie.burgalat@univ-reims.fr
@@ -35,5 +35,5 @@
 !! summary: Model miscellaneous methods module.
 !! author: J. Burgalat
-!! date: 2013-2015
+!! date: 2013-2015,2017
 
 MODULE MM_METHODS
Index: trunk/LMDZ.TITAN/libf/muphytitan/mm_microphysic.f90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/mm_microphysic.f90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/muphytitan/mm_microphysic.f90	(revision 1897)
@@ -1,3 +1,3 @@
-! Copyright 2013-2015 Université de Reims Champagne-Ardenne 
+! Copyright 2013-2015,2017 Université de Reims Champagne-Ardenne 
 ! Contributor: J. Burgalat (GSMA, URCA)
 ! email of the author : jeremie.burgalat@univ-reims.fr
@@ -35,5 +35,5 @@
 !! brief: Microphysic processes interface module.
 !! author: J. Burgalat
-!! date: 2013-2015
+!! date: 2013-2015,2017
 
 MODULE MM_MICROPHYSIC
@@ -111,14 +111,13 @@
       ! add temporary aerosols tendencies (-> m-3)
       dm0a_f = dm0a_f + zdm0a_f  ; dm3a_f = dm3a_f + zdm3a_f
-      ! sanity check for clouds tendencies
-      WHERE (mm_m0ccn+dm0n*mm_dzlev < 0) ; dm0n = -mm_m0ccn/mm_dzlev ; END WHERE
-      WHERE (mm_m3ccn+dm3n*mm_dzlev < 0) ; dm3n = -mm_m3ccn/mm_dzlev ; END WHERE
-
       ! reverse directly clouds tendencies (-> m-2)
       dm0n   = dm0n(mm_nla:1:-1) * mm_dzlev(mm_nla:1:-1)
       dm3n   = dm3n(mm_nla:1:-1) * mm_dzlev(mm_nla:1:-1)
+      ! sanity check for clouds tendencies
+      WHERE (mm_m0ccn+dm0n < 0) ; dm0n = -mm_m0ccn ; END WHERE
+      WHERE (mm_m3ccn+dm3n < 0) ; dm3n = -mm_m3ccn ; END WHERE
       DO i=1,mm_nesp
         dm3i(:,i)  = dm3i(mm_nla:1:-1,i)  * mm_dzlev(mm_nla:1:-1)
-        WHERE (mm_m3ccn+dm3n*mm_dzlev < 0) ; dm3n = -mm_m3ccn/mm_dzlev ; END WHERE
+        WHERE (mm_m3ice+dm3i < 0) ; dm3i = -mm_m3ice ; END WHERE
         dgazs(:,i) = dgazs(mm_nla:1:-1,i) 
         ! no sanity check for gazs, let's prey.
@@ -127,10 +126,4 @@
       dm0n = 0._mm_wp ; dm3n = 0._mm_wp ; dm3i = 0._mm_wp ; dgazs = 0._mm_wp
     ENDIF
-    ! sanity check
-    WHERE (mm_m0aer_s+dm0a_s*mm_dzlev < 0) ; dm0a_s = -mm_m0aer_s/mm_dzlev ; END WHERE
-    WHERE (mm_m3aer_s+dm3a_f*mm_dzlev < 0) ; dm3a_s = -mm_m3aer_s/mm_dzlev ; END WHERE
-    WHERE (mm_m0aer_f+dm0a_f*mm_dzlev < 0) ; dm0a_f = -mm_m0aer_f/mm_dzlev ; END WHERE
-    WHERE (mm_m3aer_f+dm3a_f*mm_dzlev < 0) ; dm3a_f = -mm_m3aer_f/mm_dzlev ; END WHERE
-
     ! multiply by altitude thickness and reverse vectors so they go from ground to top :)
     dm0a_s = dm0a_s(mm_nla:1:-1) * mm_dzlev(mm_nla:1:-1)
@@ -138,4 +131,9 @@
     dm0a_f = dm0a_f(mm_nla:1:-1) * mm_dzlev(mm_nla:1:-1)
     dm3a_f = dm3a_f(mm_nla:1:-1) * mm_dzlev(mm_nla:1:-1)
+    ! sanity check
+    WHERE (mm_m0aer_s+dm0a_s < 0) ; dm0a_s = -mm_m0aer_s ; END WHERE
+    WHERE (mm_m3aer_s+dm3a_f < 0) ; dm3a_s = -mm_m3aer_s ; END WHERE
+    WHERE (mm_m0aer_f+dm0a_f < 0) ; dm0a_f = -mm_m0aer_f ; END WHERE
+    WHERE (mm_m3aer_f+dm3a_f < 0) ; dm3a_f = -mm_m3aer_f ; END WHERE
     
     RETURN
@@ -167,9 +165,4 @@
     ! Calls haze microphysics
     call mm_haze_microphysics(dm0a_s,dm3a_s,dm0a_f,dm3a_f)
-    ! sanity check
-    WHERE (mm_m0aer_s+dm0a_s*mm_dzlev < 0) ; dm0a_s = -mm_m0aer_s/mm_dzlev ; END WHERE
-    WHERE (mm_m3aer_s+dm3a_f*mm_dzlev < 0) ; dm3a_s = -mm_m3aer_s/mm_dzlev ; END WHERE
-    WHERE (mm_m0aer_f+dm0a_f*mm_dzlev < 0) ; dm0a_f = -mm_m0aer_f/mm_dzlev ; END WHERE
-    WHERE (mm_m3aer_f+dm3a_f*mm_dzlev < 0) ; dm3a_f = -mm_m3aer_f/mm_dzlev ; END WHERE
     ! reverse vectors so they go from ground to top :)
     dm0a_s = dm0a_s(mm_nla:1:-1) * mm_dzlev(mm_nla:1:-1) 
@@ -177,4 +170,9 @@
     dm0a_f = dm0a_f(mm_nla:1:-1) * mm_dzlev(mm_nla:1:-1) 
     dm3a_f = dm3a_f(mm_nla:1:-1) * mm_dzlev(mm_nla:1:-1)
+    ! sanity check
+    WHERE (mm_m0aer_s+dm0a_s < 0) ; dm0a_s = -mm_m0aer_s ; END WHERE
+    WHERE (mm_m3aer_s+dm3a_f < 0) ; dm3a_s = -mm_m3aer_s ; END WHERE
+    WHERE (mm_m0aer_f+dm0a_f < 0) ; dm0a_f = -mm_m0aer_f ; END WHERE
+    WHERE (mm_m3aer_f+dm3a_f < 0) ; dm3a_f = -mm_m3aer_f ; END WHERE
     RETURN
   END FUNCTION muphys_nocld
Index: trunk/LMDZ.TITAN/libf/muphytitan/mm_mprec.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/mm_mprec.F90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/muphytitan/mm_mprec.F90	(revision 1897)
@@ -1,3 +1,3 @@
-! Copyright 2013-2015 Université de Reims Champagne-Ardenne 
+! Copyright 2013-2015,2017 Université de Reims Champagne-Ardenne 
 ! Contributor: J. Burgalat (GSMA, URCA)
 ! email of the author : jeremie.burgalat@univ-reims.fr
@@ -35,5 +35,5 @@
 !! summary: Library floating point precision module.
 !! author: J. Burgalat
-!! date: 2013-2015
+!! date: 2013-2015,2017
 
 #ifdef HAVE_CONFIG_H
Index: trunk/LMDZ.TITAN/libf/muphytitan/mmp_gcm.f90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/mmp_gcm.f90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/muphytitan/mmp_gcm.f90	(revision 1897)
@@ -1,4 +1,42 @@
+! Copyright 2017 Université de Reims Champagne-Ardenne 
+! Contributor: J. Burgalat (GSMA, URCA)
+! email of the author : jeremie.burgalat@univ-reims.fr
+! 
+! This software is a computer program whose purpose is to compute
+! microphysics processes using a two-moments scheme.
+! 
+! This library is governed by the CeCILL license under French law and
+! abiding by the rules of distribution of free software.  You can  use, 
+! modify and/ or redistribute the software under the terms of the CeCILL
+! license as circulated by CEA, CNRS and INRIA at the following URL
+! "http://www.cecill.info". 
+! 
+! As a counterpart to the access to the source code and  rights to copy,
+! modify and redistribute granted by the license, users are provided only
+! with a limited warranty  and the software's author,  the holder of the
+! economic rights,  and the successive licensors  have only  limited
+! liability. 
+! 
+! In this respect, the user's attention is drawn to the risks associated
+! with loading,  using,  modifying and/or developing or reproducing the
+! software by the user in light of its specific status of free software,
+! that may mean  that it is complicated to manipulate,  and  that  also
+! therefore means  that it is reserved for developers  and  experienced
+! professionals having in-depth computer knowledge. Users are therefore
+! encouraged to load and test the software's suitability as regards their
+! requirements in conditions enabling the security of their systems and/or 
+! data to be ensured and,  more generally, to use and operate it in the 
+! same conditions as regards security. 
+! 
+! The fact that you are presently reading this means that you have had
+! knowledge of the CeCILL license and that you accept its terms.
+
+!! file: mmp_gcm.f90
+!! summary: YAMMS interfaces for the LMDZ GCM.
+!! author: J. Burgalat
+!! date: 2017
 MODULE MMP_GCM
   !! Interface to YAMMS for the LMDZ GCM.
+  USE MMP_GLOBALS
   USE MM_LIB
   USE CFGPARSE
@@ -6,104 +44,7 @@
   IMPLICIT NONE
 
-  PUBLIC
-
-  !> Alpha function parameters. 
-  !!
-  !! It stores the parameters of the inter-moments relation functions.
-  !! 
-  !! The inter-moments relation function is represented by the sum of exponential
-  !! quadratic expressions:
-  !!
-  !! $$ 
-  !! \displaystyle \alpha(k) = \sum_{i=1}^{n} \exp\left( a_{i}\times k^{2} + 
-  !! b_{i}\times k^{2} +c_{i}\right) 
-  !! $$
-  TYPE, PUBLIC :: aprm
-    !> Quadratic coefficients of the quadratic expressions.
-    REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE :: a
-    !> Linear coefficients of the quadratic expressions.
-    REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE :: b
-    !> Free term of the quadratic expressions.
-    REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE :: c
-  END TYPE
-
-  !> Size distribution parameters derived type.
-  !!
-  !! It stores the parameters of the size distribution law for Titan.
-  !! 
-  !! The size distribution law is represented by the minimization of a sum of
-  !! power law functions:
-  !!
-  !! $$ 
-  !! \displaystyle n\left(r\right) = \frac{A_{0}}{C+\sum_{i=1}^{n} A_{i}\times
-  !!                                    \left(\frac{r}{r_{c}}\right)^{-b_{i}}}
-  !! $$
-  TYPE, PUBLIC :: nprm
-    !> Scaling factor.
-    REAL(kind=mm_wp)                            :: a0
-    !> Characterisitic radius.
-    REAL(kind=mm_wp)                            :: rc
-    !> Additional constant to the sum of power law.
-    REAL(kind=mm_wp)                            :: c
-    !> Scaling factor of each power law.
-    REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE :: a
-    !> Power of each power law.
-    REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE :: b
-  END TYPE 
-
-  !> Inter-moment relation set of parameters for the spherical mode.
-  TYPE(aprm), PUBLIC, SAVE :: mmp_asp
-  !> Inter-moment relation set of parameters for the fractal mode.
-  TYPE(aprm), PUBLIC, SAVE :: mmp_afp
-
-  !> Size-distribution law parameters of the spherical mode.
-  TYPE(nprm), PUBLIC, SAVE :: mmp_pns
-  !> Size-distribution law parameters of the fractal mode.
-  TYPE(nprm), PUBLIC, SAVE :: mmp_pnf
-
-  !> Data set for @f$<Q>_{SF}^{M0}@f$.
-  TYPE(dset2d), PUBLIC, SAVE, TARGET             :: mmp_qbsf0
-  !> Extended values of [[mmp_gcm(module):mmp_qbsf0(variable)]] dataset.
-  REAL(kind=mm_wp), PUBLIC, SAVE, DIMENSION(2,2) :: mmp_qbsf0_e
-  !> Data set for @f$<Q>_{SF}^{M3}@f$.
-  TYPE(dset2d), PUBLIC, SAVE, TARGET             :: mmp_qbsf3
-  !> Extended values of [[mmp_gcm(module):mmp_qbsf3(variable)]] dataset.
-  REAL(kind=mm_wp), PUBLIC, SAVE, DIMENSION(2,2) :: mmp_qbsf3_e
-  !> Data set for @f$<Q>_{FF}^{M0}@f$.
-  TYPE(dset2d), PUBLIC, SAVE, TARGET             :: mmp_qbff0
-  !> Extended values of [[mmp_gcm(module):mmp_qbff0(variable)]] dataset.
-  REAL(kind=mm_wp), PUBLIC, SAVE, DIMENSION(2,2) :: mmp_qbff0_e
-  
-  !> Data set for linear interpolation of transfert probability (M0/CO).
-  TYPE(dset1d), PUBLIC, SAVE, TARGET :: mmp_pco0p
-  !> Data set for linear interpolation of transfert probability (M3/CO).
-  TYPE(dset1d), PUBLIC, SAVE, TARGET :: mmp_pco3p
-  !> Data set for linear interpolation of transfert probability (M0/FM).
-  TYPE(dset1d), PUBLIC, SAVE, TARGET :: mmp_pfm0p
-  !> Data set for linear interpolation of transfert probability (M3/FM). 
-  TYPE(dset1d), PUBLIC, SAVE, TARGET :: mmp_pfm3p
-
-  !> \(b_{0}^{t}\) coefficients for Free-molecular regime kernel approximation.
-  REAL(kind=mm_wp), PUBLIC, SAVE, DIMENSION(5) :: mmp_bt0 = (/1._mm_wp,1._mm_wp,1._mm_wp,1._mm_wp,1._mm_wp/)
-  !> \(b_{3}^{t}\) coefficients for Free-molecular regime kernel approximation.
-  REAL(kind=mm_wp), PUBLIC, SAVE, DIMENSION(5) :: mmp_bt3 = (/1._mm_wp,1._mm_wp,1._mm_wp,1._mm_wp,1._mm_wp/)
-
-  !> Spherical probability transfert control flag.
-  LOGICAL, SAVE :: mmp_w_ps2s = .true.
-  !> Aerosol electric charge correction control flag.
-  LOGICAL, SAVE :: mmp_w_qe   = .true.
-
-
   CONTAINS 
     
-  SUBROUTINE abort_program(err)
-    !! Dump error message and abort the program.
-    TYPE(error), INTENT(in) :: err !! Error object.
-    WRITE(stderr,'(a)') "ERROR: "//TRIM(err%msg) 
-    CALL EXIT(err%id)
-  END SUBROUTINE abort_program
-
-
-  SUBROUTINE mmp_initialize(dt,df,rm,rho_aer,p_prod,tx_prod,rc_prod,rplanet,g0, air_rad,air_mmol,clouds,cfgpath)
+  SUBROUTINE mmp_initialize(dt,p_prod,tx_prod,rc_prod,rplanet,g0, air_rad,air_mmol,clouds,cfgpath)
     !! Initialize global parameters of the model.
     !! 
@@ -112,6 +53,5 @@
     !! default values are suitable for production runs.  
     !! @note
-    !! If the method fails to initialize parameters (i.e. returned error is not 0). Then the model
-    !! should probably be aborted as the global variables of the model will not be correctly setup.
+    !! If the subroutine fails to initialize parameters, the run is aborted.
     !!
     !! @warning
@@ -119,17 +59,12 @@
     !! initializes global variable that are not thread private.
     !!
-    !! '''
+    !! ```
     !! !$OMP SINGLE
     !! call mmp_initialize(...)
     !! !$OMP END SINGLE
+    !! ```
     !!
     REAL(kind=mm_wp), INTENT(in)           :: dt
       !! Microphysics timestep in seconds.
-    REAL(kind=mm_wp), INTENT(in)           :: df
-      !! Fractal dimension of fractal aerosol.
-    REAL(kind=mm_wp), INTENT(in)           :: rm
-      !! Monomer radius in meter.
-    REAL(kind=mm_wp), INTENT(in)           :: rho_aer
-      !! Aerosol density in \(kg.m^{-3}\).
     REAL(kind=mm_wp), INTENT(in)           :: p_prod
       !!  Aerosol production pressure level in Pa.
@@ -151,9 +86,9 @@
       !! Internal microphysic configuration file.
 
-    INTEGER          :: coag_choice
-    REAL(kind=mm_wp) :: fiad_max, fiad_min
-    LOGICAL          :: w_h_prod, w_h_sed, w_h_coag, w_c_sed, w_c_nucond, &
-                        no_fiadero, fwsed_m0, fwsed_m3
-    TYPE(error)      :: err
+    INTEGER                                           :: coag_choice
+    REAL(kind=mm_wp)                                  :: fiad_max, fiad_min,df,rm,rho_aer
+    LOGICAL                                           :: w_h_prod, w_h_sed, w_h_coag, w_c_sed, w_c_nucond, &
+                                                         no_fiadero, fwsed_m0, fwsed_m3
+    TYPE(error)                                       :: err
     INTEGER                                           :: i
     TYPE(cfgparser)                                   :: cparser
@@ -186,4 +121,7 @@
    
     ! YAMMS internal parameters:
+    err = mm_check_opt(cfg_get_value(cparser,"rm",rm),rm,50e-9_mm_wp,mm_log)
+    err = mm_check_opt(cfg_get_value(cparser,"df",df),df,2._mm_wp,mm_log)
+    err = mm_check_opt(cfg_get_value(cparser,"rho_aer",rho_aer),rho_aer,1000._mm_wp,mm_log)
     ! the following parameters are primarily used to test and debug YAMMS.
     ! They are set in an optional configuration file and default to suitable values for production runs.
